# -*- coding: UTF-8 -*-
from django.db import models

# Create your models here.
class Proveedor(models.Model):
    nombre = models.CharField(max_length=100)

    def __unicode__(self):
        return self.nombre
    class Meta:
        verbose_name_plural = 'proveedores'

class Vale(models.Model):
    no_serie = models.IntegerField(verbose_name="numero de serie")
    monto = models.DecimalField(max_digits=5, decimal_places=2)
    proveedor = models.ForeignKey(Proveedor)
    vehiculo = models.ForeignKey('parque_vehicular.Vehiculo', blank=True, null=True)
    fecha_asignacion = models.DateField(blank=True, null=True)

    def __unicode__(self):
        return u'%d %d %s' % (self.no_serie, self.monto, self.proveedor)

    class Meta:
        verbose_name_plural = 'vales'
        unique_together = ['no_serie', 'proveedor']
