from parque_vehicular.models import Marca, Tipo, Vehiculo

def importa_parque_vehicular():
	vehiculos = []
	with open('/home/juno/Proyectos/DGTIC/magic/parque_vehicular.txt') as f:
		for line in f:
			s_line = line.split("|")

			# obtener o crear marca
			_marca = s_line[0]
			marca = Marca.objects.get_or_create(nombre=_marca)[0]

			# obtener o crear tipo
			_tipo = s_line[1]
			tipo = Tipo.objects.get_or_create(tipo=_tipo, marca=marca, consumo_semanal=0)[0]

			# crear vehiculo
			_no_inventario = s_line[2]
			_placas = s_line[3]
			_modelo = s_line[4].strip() if s_line[4]!='' else None
			_color = s_line[5]
			_no_serie = s_line[6]
			_no_motor = s_line[7]
			_observaciones = s_line[8].strip()
			vehiculo = Vehiculo(
				tipo=tipo,
				no_inventario=_no_inventario,
				placas=_placas,
				modelo=_modelo,
				color=_color,
				no_serie=_no_serie,
				no_motor=_no_motor,
				observaciones=_observaciones
				)
			vehiculos.append(vehiculo)
	Vehiculo.objects.bulk_create(vehiculos)