#encoding:utf-8
from django.http import *
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from parque_vehicular.models import *
from parque_vehicular.forms import *
from coupon_manager.forms import *
from coupon_manager.models import *
from django.forms import ModelForm

from django.forms import ModelForm
from django.http import HttpResponseRedirect,HttpResponse
from django.shortcuts import render_to_response
from django.template import RequestContext, loader, Context
from django.core.urlresolvers import reverse
from django.template.response import TemplateResponse

from django.contrib import auth

# Create your views here.
#vista para redirigir hacia el index
def acceder(request):
    return render_to_response('index.html',context_instance=RequestContext(request))

#vista para acceder a la aplicacion
def login(request):
    username = request.POST.get('username', '')
    password = request.POST.get('password', '')
    user = auth.authenticate(username=username, password=password)
    if user is not None and user.is_active:
        # Correct password, and the user is marked "active"
        auth.login(request, user)
        # Redirect to a success page.
        
        #messages.success(request, 'entra pero falta checar otras cosas')
        #return render_to_response   ('index.html',context_instance=RequestContext(request))

        return HttpResponseRedirect(reverse('parque:menuinicio'))
    else:
        messages.error(request, 'error de acceso verifique su usuario y contraseña')
        return render_to_response   ('index.html',context_instance=RequestContext(request))

#vista para salir de la aplicacion
@login_required
def logout(request):
    auth.logout(request)
    return HttpResponseRedirect(reverse('parque:acceder'))



#vista para ver el perfil del usuario
@login_required(login_url='parque:acceder')
def perfil(request, user_id):
    return TemplateResponse(request, 'perfil.html' )


#vista para llamar al menu de inicio
@login_required(login_url='parque:acceder')
def menuinicio(request):
    form_informe = InformeVales()
    form_carga = AgregaVales()
    
    diccionario = { 'inicio_menu':'active', 'form_informe':form_informe,'form_carga':form_carga
        }
    return render_to_response('menuinicio.html',diccionario,context_instance=RequestContext(request))

#vista para llamar al menu de marca
@login_required(login_url='parque:acceder')
def menumarca(request):
    diccionario = { 'marca_menu':'active',
        }
    return render_to_response('menumarca.html',diccionario,context_instance=RequestContext(request))

#vista para llamar al menu de tipo
@login_required(login_url='parque:acceder')
def menutipo(request):
    diccionario = { 'tipo_menu':'active',
        }
    return render_to_response('menutipo.html',diccionario,context_instance=RequestContext(request))

#vista para llamar al menu de vehiculo
@login_required(login_url='parque:acceder')
def menuvehiculo(request):
    diccionario = { 'vehiculo_menu':'active',
        }
    return render_to_response('menuvehiculo.html',diccionario,context_instance=RequestContext(request))

#formulario de insercion del modelo marca
@login_required(login_url='parque:acceder')   
def crearmarca(request):  
    if request.method=='POST':
        form = MarcaForm(request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se guardo exitosamente la marca')
            return HttpResponseRedirect(reverse('parque:mostrarmarca'))
        else:
            messages.error(request, 'corrija los siguientes errores')
    else:
        form = MarcaForm()
    diccionario={'form':form,
            'operacion':'Crear',
            'operacion_icon':'icon-pencil',
            'marca_menu':'active'
        }
    return render_to_response('formmarca.html',diccionario,context_instance=RequestContext(request))

#formulario de insercion del modelo tipo
@login_required(login_url='parque:acceder')   
def creartipo(request):  
    if request.method=='POST':
        form = TipoForm(request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se guardo exitosamente el tipo')
            return HttpResponseRedirect(reverse('parque:mostrartipo'))
        else:
            messages.error(request, 'corrija los siguientes errores')
    else:
        form = TipoForm()
    diccionario={'form':form,
            'operacion':'Crear',
            'operacion_icon':'icon-pencil',
            'tipo_menu':'active'
        }
    return render_to_response('formtipo.html',diccionario,context_instance=RequestContext(request))

#formulario de insercion del modelo vehiculo
@login_required(login_url='parque:acceder')   
def crearvehiculo(request):  
    if request.method=='POST':
        form = VehiculoForm(request.POST)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se guardo exitosamente el vehiculo')
            return HttpResponseRedirect(reverse('parque:mostrarvehiculo'))
        else:
            messages.error(request, 'corrija los siguientes errores')
    else:
        form = VehiculoForm()
    diccionario={'form':form,
            'operacion':'Crear',
            'operacion_icon':'icon-pencil',
            'tipo_menu':'active'
        }
    return render_to_response('formvehiculo.html',diccionario,context_instance=RequestContext(request))

#muestra todos los registros del modelo marca
@login_required(login_url='parque:acceder')
def mostrarmarca(request):
    datos = Marca.objects.all()
    informacion={'datos':datos,
            'marca_menu':'active'
            }
    return render_to_response('mostrarmarca.html',informacion,context_instance=RequestContext(request)) 

#muestra todos los registros del modelo tipo
@login_required(login_url='parque:acceder')
def mostrartipo(request):
    datos = Tipo.objects.all()
    informacion={'datos':datos,
            'tipo_menu':'active'
            }
    return render_to_response('mostrartipo.html',informacion,context_instance=RequestContext(request))

#muestra todos los registros del modelo vehiculo
@login_required(login_url='parque:acceder')
def mostrarvehiculo(request):
    datos = Vehiculo.objects.all()
    informacion={'datos':datos,
            'vehiculo_menu':'active'
            }
    return render_to_response('mostrarvehiculo.html',informacion,context_instance=RequestContext(request))

#formulario de edicion del modelo marca especifico por el id
@login_required(login_url='parque:acceder')
def editarmarca(request,marca_id):
    marca = Marca.objects.get(pk=marca_id)   
    if request.method=='POST':
        form = MarcaForm(request.POST,instance=marca)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se actualizo exitosamente la marca')
            return HttpResponseRedirect(reverse('parque:mostrarmarca'))
    else:
        form = MarcaForm(instance=marca)
        diccionario={'form':form,
            'operacion':'Editar',
            'operacion_icon':'icon-edit',
            'marca_menu':'active'
            }           
    return render_to_response('formmarca.html',diccionario,context_instance=RequestContext(request))

#formulario de edicion del modelo tipo especifico por el id
@login_required(login_url='parque:acceder')
def editartipo(request,tipo_id):
    tipo = Tipo.objects.get(pk=tipo_id)   
    if request.method=='POST':
        form = TipoForm(request.POST,instance=tipo)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se actualizo exitosamente el tipo')
            return HttpResponseRedirect(reverse('parque:mostrartipo'))
    else:
        form = TipoForm(instance=tipo)
        diccionario={'form':form,
            'operacion':'Editar',
            'operacion_icon':'icon-edit',
            'autoridad_menu':'active'
            }           
    return render_to_response('formtipo.html',diccionario,context_instance=RequestContext(request))

#formulario de edicion del modelo vehiculo especifico por el id
@login_required(login_url='parque:acceder')
def editarvehiculo(request,vehiculo_id):
    vehiculo = Vehiculo.objects.get(pk=vehiculo_id)   
    if request.method=='POST':
        form = VehiculoForm(request.POST,instance=vehiculo)
        if form.is_valid():
            form.save()
            messages.success(request, 'Se actualizo exitosamente el vehiculo')
            return HttpResponseRedirect(reverse('parque:mostrarvehiculo'))
    else:
        form = VehiculoForm(instance=vehiculo)
        diccionario={'form':form,
            'operacion':'Editar',
            'operacion_icon':'icon-edit',
            'autoridad_menu':'active'
            }           
    return render_to_response('formvehiculo.html',diccionario,context_instance=RequestContext(request))

#elimina un registro especifico por el id del modelo marca
@login_required(login_url='parque:acceder')
def borrarmarca(request,marca_id):
    marca = Marca.objects.get(pk=marca_id)   
    marca.delete()
    messages.warning(request, 'Se elimino la marca')
    return HttpResponseRedirect(reverse('parque:mostrarmarca'))

#elimina un registro especifico por el id del modelo tipo
@login_required(login_url='parque:acceder')
def borrartipo(request,tipo_id):
    tipo = Tipo.objects.get(pk=tipo_id)   
    tipo.delete()
    messages.warning(request, 'Se elimino el tipo')
    return HttpResponseRedirect(reverse('parque:mostrartipo'))

#elimina un registro especifico por el id del modelo vehiculo
@login_required(login_url='parque:acceder')
def borrarvehiculo(request,vehiculo_id):
    vehiculo = Vehiculo.objects.get(pk=vehiculo_id)   
    vehiculo.delete()
    messages.warning(request, 'Se elimino el vehiculo')
    return HttpResponseRedirect(reverse('parque:mostrarvehiculo'))